

//////////////////////////////////////////////////////////////////
//                                                              //
//           PLINK (c) 2005-2006 Shaun Purcell                  //
//                                                              //
// This file is distributed under the GNU General Public        //
// License, Version 2.  Please see the file COPYING for more    //
// details                                                      //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef __OPTIONS_H__
#define __OPTIONS_H__

#include <string>
#include <vector>
#include "plink.h"

using namespace std;

class par {
  
 public:
  
  static bool verbose;
  static bool debug;
  static bool web_check;
  static bool recode;
  static bool recode_12;
  static bool recode_AD;
  static bool recode_AD_fixed;
  static bool recode_jes;
  static bool list_by_allele; 
  static bool plist;
  static string plist_fid1;
  static string plist_iid1;
  static string plist_fid2;
  static string plist_iid2;
  static bool merge_data;
  static int  merge_mode;
  static bool merge_binary;
  static bool merge_list;
  static string merge_list_filename;
  static string merge_pedfile;
  static string merge_mapfile;
  static string merge_bedfile;
  static string merge_bimfile;
  static string merge_famfile;

  static bool flip_strand;
  static string flip_file;
  static bool read_bitfile;
  static bool write_bitfile;
  static string bitfilename;
  static string bitfilename_fam;
  static string bitfilename_map;

  static bool SNP_major;
  static bool out_SNP_major;

  static string pedfile;
  static string mapfile;
  static string fileroot;
  static bool map3;

  static string output_file_name;
  static bool silent;

  static string missing_genotype;
  static string missing_phenotype;
  static bool ignore_missing_sex;

  static bool pheno_file;
  static bool covar_file;

  static int mult_pheno;
  static int mult_covar;
  static int mult_clst;

  static string pheno_filename;
  static string covar_filename;

  static bool cm_map;
  static double grid;
  static double fringe;
  static bool singlepoint;
  static int inter_grid;

  static bool done_global_pihat;

  static bool sol_family;

  static bool summ_nonfounders;
  static bool has_nonfounders;

  static bool report_missing;
  static bool test_missing;
  static bool mishap_test;
  static int  mishap_window;

  static double min_af;
  static double max_af;
  static int min_geno_cell;

  static vector<bool> chr_haploid;
  static vector<bool> chr_sex;
  static bool species_dog;
  static int run_start;
  static int run_end;
  static int run_chr;
  static string m1;
  static string m2;
  static double window;
  static bool position_window;
  static int from_window;
  static int to_window;

  static bool qt;
  static bool bt;
  static bool coding01;
  static bool ignore_phenotypes;
  static bool SD;
  static bool CP;
  static bool affpair;  
  static bool remove_unaffected_pairs;
  static bool fix_prev;
  static double fixed_prev;

  static string tagfile;
  static string mapfile_impute;
  static bool make_tags;
  static bool impute_tags;
  static bool sliding_window;
  static int sliding_window_size;

  static bool phase_snps;
  static double hap_post_prob;
  static double hap_missing_geno;
  static double hap_min_phase_prob;
  static int hap_max_nf_phases;
  static bool display_hap_freqs;
  static bool test_hap_CC;
  static bool test_hap_TDT;
  static bool test_hap_only;
  static bool display_phase_probs;

  static bool assoc_test;
  static bool assoc_test_alt_perm;
  static bool full_model_assoc;
  static bool qt_with_covariates;

  static bool model_perm_best;
  static bool model_perm_gen;
  static bool model_perm_dom;
  static bool model_perm_rec;
  static bool model_perm_trend;

  static bool assoc_gxe;

  static bool QTDT_test;
  static bool QFAM_total;
  static bool QFAM_between;
  static bool QFAM_within1;
  static bool QFAM_within2;
  
  static bool TDT_test;
  static bool perm_TDT_basic;
  static bool perm_TDT_parent;
  static bool discordant_parents;
  static bool parent_of_origin;
  static bool perm_POO_poo;
  static bool perm_POO_pat;
  static bool perm_POO_mat;
  static bool perm_POO_best;
  static bool built_families;

  static bool MENDEL_test;
  static bool MENDEL_report;
  static double MENDEL_snp;
  static double MENDEL_ind;

  static bool HWD_test;
  static bool HWD_report;
  static double HWD_limit;
  static bool HWD_standard;
  static bool HWD_filter_on_all;

  static bool CMH_test_1;
  static bool CMH_test_2;
  static bool CMH_test_ORD;
  static bool breslowday;

  static bool OR_homog_test;

  static double ci_level;
  static bool display_ci;

  static bool pfilter;
  static double pfvalue;

  static bool multtest;
  static bool use_GC;

  static bool ibs_sharing_test;

  static bool dump_set;
  static string dump_set_file;
  static bool exclude_set;

  static bool dump_gene;
  static string dump_genename;
  
  static bool hotel;

  static bool set_test;
  static int set_min;
  static int set_max;
  static string setfile;
  static bool permute_within_sol;
  static bool boot;
  static bool disp_r1;
  static bool disp_r2;
  static bool disp_r_window;
  static int disp_r_window_snp;

  static bool prune_ld;
  static bool prune_ld_pairwise;
  static double prune_ld_vif;
  static double prune_ld_r2;
  static int prune_ld_win;
  static int prune_ld_step;

  static bool epistasis;
  static bool epi_caseonly;
  static double epi_caseonly_kb_gap;
  static bool epi_filter;
  static double epi_alpha1;  
  static double epi_alpha2;
  static bool set_by_set;
  static bool epi_genebased;
  static double epi_vif;
  static bool epi_quickscan;

  static bool   inbreeding;
  static bool homo_run;
  static int homo_run_length;
  static bool homo_run_length_kb;
  static int homo_run_het;
  static bool homo_summary_allelic_match;
  static double fuzzy_homo;

  static bool ibs_run;
  static int ibs_run_length_snps;
  static int ibs_run_length_kb;
  static double ibs_run_density;
  static int ibs_inner_run_length_kb;
  static int ibs_inner_run_length_snp;
  static int ibs_join_kb;
  static int ibs_join_snp;
  static int ibs_run_missing;
  static int ibs_run_0;
  static int ibs_inter_snp_distance;
  static bool ibs_2only;

  static bool miss_run;
  static int miss_run_length;
  static bool miss_run_length_kb;
  static double miss_run_level;

  static bool mk_datfile;
  static bool segment_output;
  static bool segment_output_started;
  static bool read_segment_file;
  static string read_segment_filename;

  static int segment_inter_snp_distance;
  static bool multi_output;
  static bool gmulti_output;
  static bool genome_output;
  static bool summary_ibd_output;
  static double IBD_threshold;
  static double segment_threshold_start;
  static double segment_threshold_finish;
  static bool nudge;
  static bool bound;
  static bool show_impossible_IBD;

  static bool permute;
  static int replicates;
  static bool mperm_save_best;
  static bool mperm_save_all;
  static bool adaptive_perm;
  static int adaptive_min;
  static int adaptive_max;
  static int adaptive_interval;
  static double adaptive_interval2;
  static double adaptive_alpha;
  static double adaptive_ci;

  static bool perm_genedrop;
  static bool perm_genedrop_and_swap;
  static bool perm_genedrop_unrel;
  static bool perm_genedrop_parents;
  static bool perm_genedrop_sibships;


  static bool FIXED;
  static Z FIX_IBD;
  static double FIX_p;

  static bool matrix;
  static bool cluster;
  static bool cluster_ibm_constraint;
  static double cluster_ibm_constraint_value;
  static bool cluster_missing;
  static bool cluster_selcon;
  static string cluster_selcon_file;
  static int max_cluster_N;
  static double merge_p;
  static int ibstest_gap;
  static int max_cluster_size;
  static int max_cluster_case;
  static int max_cluster_control;
  static bool include_cluster;
  static bool include_cluster_from_file;
  static string include_cluster_filename;
  static int analyse_cluster;
  static bool cluster_on_phenotype;
  static bool cluster_on_mcc;
  static int min_neighbour;
  static int max_neighbour;
  static bool outlier_detection;
  static bool bmatch;
  static bool bmatch_usertype;
  static bool qmatch;
  static string bmatch_filename;
  static string bmatch_direction_filename;  
  static string qmatch_filename;
  static string qmatch_threshold_filename;  
  
  static bool include_all_pairs;
  static double include_all_z1;    

  static double MIN_PIHAT;
  static double MAX_PIHAT;
  static double MAX_CORR_PIHAT_PIHAT_G;
  static double MAX_GENO_MISSING;
  static double MAX_IND_MISSING;
  static int    MAX_LINE_LENGTH;

  static bool remove_indiv;
  static string remove_indiv_list;
  static bool remove_keep_indiv;

  static bool af_read;
  static bool af_write;

  static bool ibd_read;
  static string ibd_file;

  static string af_file;
  static bool af_count;
  
  static bool inc_write;
  static bool inc_read;
  static string inc_file;

  static int pp_maxsnp;
  static int pp_maxfid;
  static int pp_maxiid;
  
  static int BATCH_SIZE;
  
  static bool plink;
};


void setOptions(CArgs &);



#endif
